package eu.clarin.cmdi.mdservice.action;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;

import eu.clarin.cmdi.mdservice.internal.Cache;

import net.sf.json.JSONObject;
import net.sf.json.xml.XMLSerializer;

/*
 * import org.jzkit.service.*; 
import org.jzkit.search.provider.iface.Searchable;
import org.jzkit.search.provider.iface.SearchableFactory;
*/

/**
 * This is meant for administrative tasks. Currently only action is related to <code>cache</code> viewing and clearing.
 *
 */
public class AdminAction extends GenericAction {

	private static final long serialVersionUID = 1L;
	
	
	private String date;
	private String datefrom;
	private String dateto;
	
	public String getDate() {
		return date;
	}

	public void setDate(String date) {
		this.date = date;
	}
	
	public String getDatefrom() {
		return datefrom;
	}

	public void setDatefrom(String datefrom) {
		this.datefrom = datefrom;
	}

	public String getDateto() {
		return dateto;
	}

	public void setDateto(String dateto) {
		this.dateto = dateto;
	}

	
	@Override 
	public String getFullFormat() {
		return "admin2" + getFormat();
	}
	
	public String getBaseURI() { 
		String uri = "file:/" + Cache.getCache().getCacheIndexPath();		
		return uri;
	}

	public String del() throws Exception {
		
		//String connection_descriptor_string = "";
		//SearchableFactory sf = app_ctx.getBean("SearchableFactory");
	    //Searchable z3950_target = sf.create(connection_descriptor_string);//create(new IRServiceDescriptor("proto=z3950,addr=www.lcweb.gov:210,code=LC,shortname=\"Library of congress\",longname="\"Library of congress\""));

		//getServletRequest().getRemoteUser()
		if (getServletRequest().getRemoteUser() != null){
			if ( getServletRequest().getRemoteUser().toLowerCase().equals("admin")){
				HashMap<String,String> clear_params = new HashMap<String,String>();
				if (this.getActionkey() != null){
					clear_params.put("type", getActionkey());	
				}
				if (this.getRepository() != null){
					clear_params.put("repository", String.valueOf(getRepository()));	
				}	
				if (this.getDate() != null){
					clear_params.put("date", getDate());	
				}
				if (this.getDatefrom() != null){
					clear_params.put("datefrom", getDatefrom());	
				}
				if (this.getDateto() != null){
					clear_params.put("dateto", getDateto());	
				}
				//int removed;
				this.setResultStream(Cache.getCache().clear(clear_params));
				
				//String ret = "1";
				//this.setResultStream( new ByteArrayInputStream(String.valueOf(removed).getBytes()));
				
				return SUCCESS;

			}
		}
		
		return ERROR;
		
	}
	
	}
